033.搜索旋转排序数组
作者:沉默王二
发布时间:2024-06-03T17:16:23.833+0800
鲁迅曾说,任何时候,你都不能忘记成长,你都不能忘记你是谁,你都不能忘记你从哪里来,你都不能忘记你要到哪里去。这是一个人的成长史,也是一个民族的成长史。——《狂人日记》
技术派阅读地址:https://paicoding.com/column/7/33
语雀专栏地址+密码可通过星球置顶帖查看:https://t.zsxq.com/15rEo9Pdu
这道题可以说完全重写了,给出 1 道大家完全都能掌握的题解( 利用栈这个数据结构)。
增加代码注释,这样大家更容易看懂并掌握题解;
增加参考资料,这样大家可以从零基础直接开刷,减轻新手刷题的阻力;
增加手绘图,这样大家更容易理解解题思路;
增加 ACM 输入输出,这样大家可以在 Intellij IDEA 中进行调试;
增加题解模拟,这样大家可以根据题解模拟整个题解过程,看完会有一种“哦哦”恍然大悟的感觉;
图片上传至 OSS 并配合 CDN,提升大家在技术派网站中的阅读体感。
另外,这一版本会作为 PDF 的终稿随后在星球进行发布。
题意
整数数组 nums 按升序排列,数组中的值 互不相同 。
在传递给方法之前,nums 在预先未知的某个下标 k(0 <= k < nums.length)上进行了旋转,使数组变为 [nums[k], nums[k+1], ..., nums[n-1], nums[0], nums[1], ..., nums[k-1]](下标 从 0 开始计数)。例如, [0,1,2,4,5,6,7] 在下标 3 处经旋转后可能变为 [4,5,6,7,0,1,2] 。
给你旋转后的数组 nums 和一个整数 target,如果 nums 中存在这个目标值 target,则返回它的下标,否则返回 -1 。
你必须设计一个时间复杂度为 O(log n) 的算法解决此问题。
难度
中等
示例
textjavascripttypescriptcsshtmlbashjsonmarkdownpythonjavaccpprubygorustphpsqlyaml Copy
输入:nums = [4,5,6,7,0,1,2], target = 0
输出:4
输入:nums = [4,5,6,7,0,1,2], target = 3
输出:-1
### 分析 1
这道题咋眼一看,有点绕,给一个旋转后的数组,和一个目标值,并要求我们找到这个目标值的下标。
但稍微分析一下就知道,就是在一个数组当中查找一个目标值,如果不考虑时间复杂度的话,我们可以直接遍历一遍,找到就返回下标,找不到就返回-1。
超级简单:
textjavascripttypescriptcsshtmlbashjsonmarkdownpythonjavaccpprubygorustphpsqlyaml Copy
class Solution {
public int search(int[] nums, int target) {
for(int i = 0;i < nums.length;i++){
if(nums[i] == target)
return i;
}
return -1;
}
}
来看一下效率:
这效率也太高了吧,但是题目要求时间复杂度为$O(\log{n})$,那么我们就不能这么简单的去遍历了。
分析 2
我们知道,在一个有序的数组里面去判断一个数是否存在,可以利用二分查找,时间复杂度刚好就是$O(\log{n})$。
但这道题只是部分有序(因为旋转了),该怎么去判断呢?
闭上眼,想一下。
从任意位置将这个部分有序的数组分开,那么分开之后的两部分必然有一部分是有序的!
比如:
textjavascripttypescriptcsshtmlbashjsonmarkdownpythonjavaccpprubygorustphpsqlyaml Copy
nums = [4,5,6,7,0,1,2]
nums = [4] [5,6,7,0,1,2] breakPos = 1
nums = [4,5] [6,7,0,1,2] breakPos = 2
nums = [4,5,6] [7,0,1,2] breakPos = 3
nums = [4,5,6,7] [0,1,2] breakPos = 4
nums = [4,5,6,7,0] [1,2] breakPos = 5
nums = [4,5,6,7,0,1] [2] breakPos = 6
果然,至少有一部分是有序的。那我们是不是就可以从有序的部分当中去寻找 target 呢?
可以是可以,但时间复杂度并不是 $O(\log{n})$,还要加上 breakPos 分割后无序的部分,合起来就是$O(n + \log{n})$,显然也不符合题目的要求。
考虑下面的思路:
如果[lef,breakPos - 1]是有序的,而且nums[lef] <= target && target < nums[breakPos],那么答案肯定在[lef, breakPos - 1],直接调整上界rig到breakPos - 1。
如果[breakPos,rig]是有序的,而且nums[breakPos] < target && target <= nums[rig],那么答案肯定在[breakPos,rig]中,调整下界lef到breakPos即可。
也就是说,我们通过判断有序的部分,来决定下一步的查找范围。
只有在有序区间内才可以通过区间两端的数值判断 target 是否在其中。
判断有序区间还是乱序区间:left <= right 是顺序区间,否则乱序区间。
每次二分至少存在一个有序区间。
textjavascripttypescriptcsshtmlbashjsonmarkdownpythonjavaccpprubygorustphpsqlyaml Copy
class Solution {
public int search(int[] nums, int target) {
int siz = nums.length; // 数组长度
int lef = 0, rig = siz - 1; // 初始化左右指针
while (lef <= rig) { // 当左指针小于等于右指针时进行循环
int mid = (lef + rig) >> 1; // 计算中间索引,使用右移运算符相当于除以 2
if (nums[mid] == target) // 如果中间元素等于目标值,返回中间索引
return mid;
if (nums[0] <= nums[mid]) { // 如果左半部分有序
if (nums[0] <= target && target < nums[mid]) // 如果目标值在左半部分范围内
rig = mid - 1; // 移动右指针
else
lef = mid + 1; // 否则移动左指针
} else { // 右半部分有序
if (nums[mid] < target && target <= nums[siz - 1]) // 如果目标值在右半部分范围内
lef = mid + 1; // 移动左指针
else
rig = mid - 1; // 否则移动右指针
}
}
return -1; // 如果未找到目标值,返回 -1
}
}
我们来分析一下代码的关键部分:
第一步,初始化:
siz:数组长度。
lef 和 rig:左右指针,分别初始化为数组的第一个和最后一个索引。
第二步,二分查找:
计算中间索引 mid;如果 nums[mid] 等于目标值 target,直接返回 mid。
检查数组的左半部分是否有序(nums[0] <= nums[mid])。
如果左半部分有序,并且目标值在左半部分范围内(nums[0] <= target && target < nums[mid]),移动右指针到 mid - 1;否则,移动左指针到 mid + 1。
如果右半部分有序,并且目标值在右半部分范围内(nums[mid] < target && target <= nums[siz - 1]),移动左指针到 mid + 1;否则,移动右指针到 mid - 1。
第三步,如果循环结束仍未找到目标值,返回 -1。
假设数组为 [4, 5, 6, 7, 0, 1, 2],目标值 target 为 0,我们来模拟一下整个题解过程:
初始 lef = 0,rig = 6,mid = 3,nums[mid] = 7。
nums[0] <= nums[mid],左半部分有序。
0 不在左半部分范围内,移动左指针 lef = 4。
更新 mid = 5,nums[mid] = 1。
nums[4] <= nums[mid],右半部分有序。
0 在右半部分范围内,移动右指针 rig = 4。
更新 mid = 4,nums[mid] = 0,找到目标值,返回 4。
好,来看一下题解效率:
总结
遇到 O(log n) 的题目,首先想到的就是二分查找,这道题也是一样,只不过在二分查找的基础上,增加了一些判断条件。而二分查找的关键是找到有序的部分。
力扣链接:https://leetcode.cn/problems/search-in-rotated-sorted-array/